routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
  if (Auth::guest())
    return view('auth/login');
  else
    return view('home');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home.index');

Route::get('usuario/permisos', 'BomberoController@permisos')->name('bombero.permisos');
Route::put('usuario/modificar', 'BomberoController@permisosupdate')->name('bombero.permisosupdate');
Route::resource('bombero','BomberoController',['except' => ['show']]);

Route::get('asistencia/rango', 'AsistenciaController@rango')->name('AsistenciaController.rango');
Route::resource('asistencia','AsistenciaController');

Route::get('puntuacion/variables', 'PuntuacionController@variables')->name('puntuacion.variables');
Route::get('puntuacion/anual', 'PuntuacionController@anual')->name('puntuacion.anual');
Route::get('puntuacion/anual/{bombero}/{inicio}/{fin}', 'PuntuacionController@tabla_anual')->name('puntuacion.tabla_anual');
Route::get('puntuacion/bomberos/{mes}/{anio}', 'PuntuacionController@bomberos')->name('puntuacion.bomberos');
Route::get('puntuacion/listar/{mes}/{anio}', 'PuntuacionController@listar')->name('puntuacion.listar');
Route::get('puntuacion/{mes}/{anio}/{bombero}/puntuacionmes', 'PuntuacionController@puntuacionmes')->name('puntuacion.puntuacionmes');
Route::post('puntuacion/variables', 'PuntuacionController@modificaar_variables')->name('puntuacion.modificar');
Route::resource('puntuacion','PuntuacionController');

Route::resource('vehiculo','VehiculoController');

Route::resource('material','MaterialController');

Route::get('servicio/llamada', 'ServicioController@llamada')->name('servicio.llamada');
Route::get('servicio/ultimos', 'ServicioController@ultimos')->name('servicio.ultimos');
Route::get('servicio/activo/{id}', 'ServicioController@finalizarActivo')->name('servicio.finalizarActivo');
route::get('servicio/finalizado', 'ServicioController@finalizado')->name('servicio.finalizado');
Route::get('servicio/estadistica', 'ServicioController@estadistica')->name('servicio.estadistica');
Route::get('servicio/{mes}/{anio}/tabla', 'ServicioController@tabla')->name('servicio.tabla');
Route::post('servicio/guardarPresentes', 'ServicioController@guardar_presentes')->name('servicio.guardar_presentes');
Route::post('servicio/iniciado', 'ServicioController@iniciado')->name('servicio.iniciado');
Route::put('servicio/editarPresentes', 'ServicioController@editar_presentes')->name('servicio.editar_presentes');
Route::put('servicio/activo/{id}/finalizar', 'ServicioController@guardarActivo')->name('servicio.guardarActivo');
Route::put('servicio/activo/{id}/salida', 'ServicioController@salida')->name('servicio.salida');
Route::resource('servicio','ServicioController');

Route::get('ingreso/{id}', 'IngresoController@show')->name('ingreso.show');
Route::get('ingreso/presentes/edit/{servicio}', 'IngresoController@editPresentes')->name('ingreso.editPresentes');
Route::get('ingreso/presentes/{servicio}/{acargo}', 'IngresoController@indexPresentes')->name('ingreso.indexPresentes');
Route::post('ingreso', 'IngresoController@guardarIngreso')->name('ingreso.guardarIngreso');
Route::delete('ingreso/{id}', 'IngresoController@borrarIngreso')->name('ingreso.borrarIngreso');

app/Vehiculo.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Vehiculo extends Model
{
  protected $table = 'vehiculo';
  protected $fillable = [
      'patente','num_movil','detalle','estado',
  ];

  public function ScopePatente($query,$patente)
  {
    $patente=strtoupper($patente);
    if (trim($patente)!="") {
      $query->where('patente','LIKE',"%$patente%");
    }
  }

  public function ScopeMovil($query,$movil)
  {
    if ($movil>0) {
      $query->where('id',$movil);
    }
  }

  public function ScopeEstado($query,$estado)
  {
    if ($estado>0) {
      $query->where('estado',$estado);
    }
  }
  public function materiales(){
    return $this->hasMany(Material::class);
  }

  public function servicios(){
    return $this->hasMany(VehiculoServicio::class);
  }

}

app/Http/Controllers/VehiculoController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Http\Requests;
use App\Vehiculo;
use Validator;
use App\Http\Requests\VehiculoRequest;
use Illuminate\Support\Facades\Auth;

class VehiculoController extends Controller
{
  public function __construct()
  {
      $this->middleware('auth');
  }
  public function index(VehiculoRequest $request)
  {
      $vehiculos=Vehiculo::movil($request['movil'])->estado($request['estado'])->patente($request['patente'])->paginate(8);
      return view('vehiculo/lista',compact('vehiculos'));
  }
  public function create()
  {
      if(Auth::user()->admin){
        return view('vehiculo/alta');
      }
      return view('auth/alerta');
  }
  public function edit($id)
  {
      if(Auth::user()->admin){
        $vehiculo=Vehiculo::find($id);
        return view('vehiculo/editar',compact('vehiculo'));
      }
      return view('auth/alerta');
  }

  public function show($id){
      $vehiculo=Vehiculo::find($id);
      return view('vehiculo/info',compact('vehiculo'));
  }

  public function destroy(Request $request,$id)
  {
    if(Auth::user()->admin){
      $vehiculo=Vehiculo::find($id);
      if (count($vehiculo->servicios)==0) {
        $vehiculo->delete();
      }
      return redirect()->route('vehiculo.index');
    }
  }
  public function update(VehiculoRequest $data, $id)
  {
    if(Auth::user()->admin){
      if($data['patente']!=""){
        $data['patente']=strtoupper($data->patente);
      }
      $vehiculo=Vehiculo::findorfail($id)->update($data->all());
      return redirect()->route('vehiculo.index');
    }
  }

  public function store(VehiculoRequest $data)
  {
    if(Auth::user()->admin){
      if($data['patente']!=""){
        $data['patente']=strtoupper($data->patente);
      }
      Vehiculo::create($data->all());
      return redirect()->route('vehiculo.index');
    }
  }

}

resources/views/vehiculo/alta.blade.php
@extends('layouts.app')

@section('content')
<article class="col-md-12">
<div class="panel panel-default">
  <div id="breadcrumb" class="panel-heading">
    <span class="fa fa-truck" aria-hidden="true"></span>
    <h4>Alta de vehiculo</h4>
  </div>
  <div class="panel-body">
    {!! Form::open([ 'route' => 'vehiculo.store', 'class' => 'form-horizontal', 'method' => 'POST']) !!}

      <div class="form-group {{ $errors->has('patente') ? ' has-error' : '' }}">
        {!! Form::label('patente', 'Patente',['class' => 'col-md-4 control-label']) !!}
        <div class="col-md-6">
            {!! Form::text('patente', null, ['class' => 'form-control']) !!}

            @if ($errors->has('patente'))
                <span class="help-block">
                    <strong>{{ $errors->first('patente') }} Usar: AAA 999 o AA 999 AA</strong>
                </span>
            @endif
        </div>
      </div>

      <div class="form-group {{ $errors->has('num_movil') ? ' has-error' : '' }}">
        {!! Form::label('num_movil', 'Numero de Movil',['class' => 'col-md-4 control-label']) !!}
        <div class="col-md-6">
            {!! Form::text('num_movil', null, ['class' => 'form-control','placeholder'=>'1']) !!}

            @if ($errors->has('num_movil'))
                <span class="help-block">
                    <strong>{{ $errors->first('num_movil') }}</strong>
                </span>
            @endif
        </div>
      </div>

      <div class="form-group {{ $errors->has('estado') ? ' has-error' : '' }}">
        {!! Form::label('estado', "Estado", ['class' => 'col-md-4 control-label']) !!}
        <div class="col-md-2">
          {{Form::select('estado',config('selects.estadovehiculo'), 2, ['class' => 'form-control'])}}

          @if ($errors->has('estado'))
              <span class="help-block">
                  <strong>{{ $errors->first('estado') }}</strong>
              </span>
          @endif
        </div>
      </div>

      <div class="form-group {{ $errors->has('detalle') ? ' has-error' : '' }}">
        {!! Form::label('detalle', 'Detalle',['class' => 'col-sm-4 control-label']) !!}
        <div class="col-sm-6">
            {!! Form::textarea('detalle', null, ['class' => 'form-control' , 'rows' => '8']) !!}

            @if ($errors->has('detalle'))
                <span class="help-block">
                    <strong>{{ $errors->first('detalle') }}</strong>
                </span>
            @endif
        </div>
      </div>

      <div class="form-group">
        <div class="col-md-6 col-md-offset-4">
          <button type="submit" class="btn btn-primary">
              <i class=" glyphicon glyphicon-floppy-save"></i> Registrar
          </button>
        </div>
      </div>

    {!! Form::close() !!}
  </div>
</div>
</article>
@endsection

resources/views/vehiculo/editar.blade.php
@extends('layouts.app')

@section('content')
<article class="col-md-12">
  <div class="panel panel-default">
    <div id="breadcrumb" class="panel-heading">
      <span class="fa fa-edit" aria-hidden="true"></span>
      <h4>Modificar vehiculo</h4>
    </div>
    <div class="panel-body">
      {!! Form::open([ 'route' => ['vehiculo.update', $vehiculo ], 'class' => 'form-horizontal', 'method' => 'PUT', 'files' => true]) !!}

        <div class="form-group {{ $errors->has('patente') ? ' has-error' : '' }}">
          {!! Form::label('patente', 'Patente',['class' => 'col-md-4 control-label']) !!}
          <div class="col-md-6">
              {!! Form::text('patente', $vehiculo->patente, ['class' => 'form-control']) !!}

              @if ($errors->has('patente'))
                  <span class="help-block">
                      <strong>{{ $errors->first('patente') }}</strong>
                  </span>
              @endif
          </div>
        </div>

        <div class="form-group {{ $errors->has('num_movil') ? ' has-error' : '' }}">
          {!! Form::label('num_movil', 'Numero de Movil',['class' => 'col-md-4 control-label']) !!}
          <div class="col-md-6">
              {!! Form::text('num_movil', $vehiculo->num_movil, ['class' => 'form-control']) !!}

              @if ($errors->has('num_movil'))
                  <span class="help-block">
                      <strong>{{ $errors->first('num_movil') }}</strong>
                  </span>
              @endif
          </div>
        </div>

        <div class="form-group {{ $errors->has('estado') ? ' has-error' : '' }}">
          {!! Form::label('estado', "Estado", ['class' => 'col-md-4 control-label']) !!}
          <div class="col-md-2">
            {{Form::select('estado',config('selects.estadovehiculo'), $vehiculo->estado, ['class' => 'form-control'])}}

            @if ($errors->has('estado'))
                <span class="help-block">
                    <strong>{{ $errors->first('estado') }}</strong>
                </span>
            @endif
          </div>
        </div>

        <div class="form-group {{ $errors->has('detalle') ? ' has-error' : '' }}">
          {!! Form::label('detalle', 'Detalle',['class' => 'col-sm-4 control-label']) !!}
          <div class="col-sm-6">
              {!! Form::textarea('detalle',  $vehiculo->detalle, ['class' => 'form-control' , 'rows' => '8']) !!}

              @if ($errors->has('detalle'))
                  <span class="help-block">
                      <strong>{{ $errors->first('detalle') }}</strong>
                  </span>
              @endif
          </div>
        </div>

        <div class="form-group">
          <div class="col-md-6 col-md-offset-4">
            <button type="submit" class="btn btn-primary">
                <i class=" glyphicon glyphicon-floppy-save"></i> Editar
            </button>
          </div>
        </div>

      {!! Form::close() !!}
    </div>
  </div>
</article>
@endsection

resources/views/vehiculo/info.blade.php
@extends('layouts.app')

@section('content')
<article class="col-sm-12">
  <div class="panel panel-default">
    <div class="panel-heading">
      Materiales del movil N° {{$vehiculo->num_movil}}
    </div>
    <div class="panel-body">
      <div class="col-sm-5 form-horizontal">
        <br>
        <div class="form-group">
          {!! Form::label('patente', 'Patente',['class' => 'col-md-4 control-label']) !!}
          <div class="col-md-7">
              {!! Form::text('patente', $vehiculo->patente, ['class' => 'form-control','disabled']) !!}
          </div>
        </div>

        <div class="form-group ">
          {!! Form::label('num_movil', 'Numero de Movil',['class' => 'col-md-4 control-label']) !!}
          <div class="col-md-7">
              {!! Form::text('num_movil', $vehiculo->num_movil, ['class' => 'form-control','disabled']) !!}
          </div>
        </div>

        <div class="form-group">
          {!! Form::label('estado', "Estado", ['class' => 'col-md-4 control-label']) !!}
          <div class="col-md-7">
            {{Form::select('estado',config('selects.estadovehiculo'), $vehiculo->estado, ['class' => 'form-control','disabled'])}}
          </div>
        </div>

        <div class="form-group">
          {!! Form::label('detalle', 'Detalle',['class' => 'col-sm-4 control-label']) !!}
          <div class="col-sm-7">
              {!! Form::textarea('detalle',  $vehiculo->detalle, ['class' => 'form-control' , 'rows' => '10','disabled']) !!}
          </div>
        </div>

      </div>
      <div class=" col-sm-5">
      <table  class="table table-bordered">
        <thead><!--Titulos de la tabla-->
          <tr>
            <th colspan="2" class="text-center">Materiales</th>
          </tr>
        </thead>
        <tbody><!--Contenido de la tabla-->
          @foreach ($vehiculo->materiales as $material)
            <tr>
              <td class="text-center"><a href="{{ route('material.show', $material->id) }}">{{$material->nombre}}</a></td>
              @if (Auth::user()->admin)
                <td class="text-center"><a class="glyphicon glyphicon-edit" href="{{ route('material.edit', $material->id) }}"></a></td>
              @else
                <td class="text-center">
                  <button type="submit" class="glyphicon glyphicon-ban-circle" title="Sin permisos para eliminar/modificar"></button>
                </td>
              @endif
            </tr>
          @endforeach
          </tbody>
          <tfoot>
            <tr>
              <td colspan="2" class="text-center">Detalle de Vehiculo</td>
            </tr>
          </tfoot>
          <br>
        </table>
      </div>
    </div>
  </div>
</article>
@endsection

resources/views/vehiculo/lista.blade.php
@extends('layouts.app')

@section('content')
<article class="col-md-12">
  <div class="panel panel-default">
    <div id="breadcrumb" class="panel-heading">
      <span class="fa fa-truck" aria-hidden="true"></span>
      <h4>Vehiculos</h4>
    </div>

    <div class="col-sm-12">
      <div class="col-md-6 col-sm-12 text-right" style="padding-top: 20px;">
        {{Form::model(Request::all(),['route' => 'vehiculo.index', 'class' => 'form-horizontal', 'method' => 'GET'])}}
          <div class="col-sm-3 {{ $errors->has('movil') ? ' has-error' : '' }}">
            {{Form::text('movil', null, ['placeholder'=>"1", 'class' => 'form-control'])}}
            @if ($errors->has('movil'))
                <span class="help-block">
                    <strong>{{ $errors->first('movil') }}</strong>
                </span>
            @endif
          </div>
          <div class="col-sm-3">
            {{Form::select('estado',[0=>'Estado'] +config('selects.estadovehiculo'), null, ['class' => 'form-control'])}}
          </div>
          <div class="col-sm-5">
            {{Form::text('patente', null, ['placeholder'=>"Patente", 'class' => 'form-control'])}}
          </div>
          <div class="col-sm-1">
            {{Form::submit('Buscar', ['class' => 'btn btn-primary']) }}
          </div>
        {{Form::close()}}
      </div>
    </div>

    <div class="panel-body">
      <table  class="table table-bordered">
        <thead><!--Titulos de la tabla-->
          <tr>
            <th class="text-center">
              Nro. de Unidad
            </th>
            <th class="text-center">
              Patente
            </th>
            <th class="text-center">
              Cant. Materiales
            </th>
            <th class="text-center" colspan="2">
            </th>
          </tr>
        </thead>
        <tbody><!--Contenido de la tabla-->
          @foreach ($vehiculos as $vehiculo)
            @if ($vehiculo->estado==1)
            <tr class="success">
            @else
            <tr class="danger">
            @endif
              <td class="text-center"><a href="{{ route('vehiculo.show', $vehiculo->id) }}">{{$vehiculo->num_movil}}</a>
              </td>
              <td class="text-center">{{$vehiculo->patente}}</td>
              <td class="text-center">{{count($vehiculo->materiales)}}</td>
              @if (Auth::user()->admin)
                <td class="text-center">
                @if (count($vehiculo->servicios)==0)
                {{ Form::open(['route' => ['vehiculo.destroy', $vehiculo->id], 'method' => 'delete']) }}
                  <button type="submit" class="glyphicon glyphicon-trash"></button>
                {{ Form::close() }}
                @else
                  <button type="submit" class="glyphicon glyphicon-ban-circle" title="Participo en Servicio"></button>
                @endif
                </td>
                <td class="text-center"><a class="glyphicon glyphicon-edit" href="{{ route('vehiculo.edit', $vehiculo->id) }}"></a></td>
              @else
                <td class="text-center" colspan="2">
                  <button type="submit" class="glyphicon glyphicon-ban-circle" title="Sin permisos para eliminar/modificar"></button>
                </td>
              @endif
            </tr>
          @endforeach
          </tbody>
          <tfoot>
            <tr>
              <td class="text-center" colspan="5"> Lista de vehiculos</td>
            </tr>
          </tfoot>
          <br>
        </table>
        <div class="text-center">
          {{ $vehiculos->appends(Request::all())->render()}}
        </div>
    </div>
  </div>
</article>
@endsection